﻿-- Author      : Nogarder
-- Create Date : 2015/3/2 20:54:03
RS.SpecAndSpells={}
--
RS.RoleTexture="Interface\\LFGFrame\\LFGRole"
local RoleTextureCoord={
	["TANK"]={
		Left=0.5,
		Right=0.75,
		Top=0,
		Bottom=1,
	},
	["HEALER"]={
		Left=0.75,
		Right=1,
		Top=0,
		Bottom=1,
	},
	["DAMAGER"]={
		Left=0.25,
		Right=0.5,
		Top=0,
		Bottom=1,
	},
	["NONE"]={
		Left=0,
		Right=0,
		Top=0,
		Bottom=0,
	},
}

local NameToClass={}
local NameToSpec={}
local SpecUpdateList={}
local GroupNameToRole={}
local GroupNameToStr={}
local CurrentInspectGUID=nil
local CurrentInspectName=nil
local CurrentInspectStr=nil
local NeedInspect=false
local InspectDelay=3
local LastInspectTime=0


local GetFullName=function(str)
	local name,server=UnitName(str)
	if(server and server~=" ")then
		return name.."-"..server
	else
		return name
	end
end

RS.SpecAndSpells.GetFullName=GetFullName

local StartInspect=function()
	for str,_ in pairs(SpecUpdateList) do
		CurrentInspectGUID=UnitGUID(str)
		CurrentInspectName=GetFullName(str)
		CurrentInspectStr=str
		NotifyInspect(str)
		return
	end
	--empty ,set to false
	NeedInspect=false
end


local GetStr=function(str)
	local name=GetFullName(str)
	if(name)then
		GroupNameToStr[name]=str
		local role=UnitGroupRolesAssigned(str)
		if(GroupNameToRole[name]~=role)then
			_,NameToClass[name]=UnitClass(str)
			GroupNameToRole[name]=role
			if(name==GetFullName("player"))then
				NameToSpec[name]=GetSpecialization();
			else
				SpecUpdateList[str]=true
				NeedInspect=true
			end
		end
	end
end

local UpdateGroup=function()
	GroupNameToStr={}
	GetStr("player")
	for i=1,40 do
		local str="raid"..i
		GetStr(str)
	end
end

local RS_SpecAndSpells_GetPlayerStr=function(name)
	if(name==GetFullName("player"))then
		return "player"
	end
	return GroupNameToStr[name]
end


RS.SpecAndSpells.SetPortrait=function(texture,name)
	local str=RS_SpecAndSpells_GetPlayerStr(name)
	if(str)then
		SetPortraitTexture(texture,str)
	else
		texture:SetTexture(nil)
	end
end

RS.EventHandler.RegisterEvent(0,"GROUP_ROSTER_UPDATE","SpecAndSpells",UpdateGroup)
RS.EventHandler.RegisterEvent(0,"PLAYER_ROLES_ASSIGNED","SpecAndSpells",UpdateGroup)
RS.EventHandler.RegisterEvent(0,"PLAYER_ENTERING_WORLD","SpecAndSpells",UpdateGroup)

--RS.EventHandler.RegisterEvent(1,"RS_MainFrame_OnUpdate",function(elapsed)
--	if(NeedInspect==false)then
--		return
--	end

--	LastInspectTime=LastInspectTime-elapsed
--	if(LastInspectTime>0)then
--		return
--	end
	
--	LastInspectTime=InspectDelay
	
--	StartInspect()
--end)

--RS.EventHandler.RegisterEvent(0,"INSPECT_READY","SpecAndSpells",function(guid)
--	if(guid==CurrentInspectGUID)then
--		NameToSpec[CurrentInspectName]=GetSpecialization()
--		NameToSpec[CurrentInspectStr]=nil
--		--fire a event to notify other module
--		RS.EventHandler.FireEvent(1,"SpecUpdated",CurrentInspectName)
--	end
--	StartInspect()
--end)


RS.SpecAndSpells.GetSpecIcon=function(name)
	local specid=NameToSpec[name]
	if(specid)then
		--local id, name, description, icon, background, role = GetSpecializationInfoByID(specid)
		local _,_, _, icon= GetSpecializationInfoByID(specid)
		return icon
	end
	return nil
end

RS.SpecAndSpells.GetRoleIcon=function(name)
	local role=GroupNameToRole[name]
	if(role)then
		return RoleTextureCoord[role] or {Left=0,Right=0,Top=0,Bottom=0}
	end
	return {Left=0,Right=0,Top=0,Bottom=0}
end

RS.SpecAndSpells.IsUnitActive=function(name)
	local str=GroupNameToStr[name]
	if(str)then
		if(UnitIsConnected(str) and not UnitIsDead(str) and not UnitIsGhost(str))then
			return true
		end
	end
end

-------------------

local RS_ClassSpellList={
	["PALADIN"]={
		[31821]=180,
		[6940]=120,
		[633]=600,
		[114039]=30,
		[1022]=300,
		[642]=300,
		[498]=60,
		[96231]=15,
	},
	["PRIEST"]={
		[73325]=90,
		[62618]=180,
		[33206]=180,
		[64843]=180,
		[47788]=180,
		[110744]=15,
		[15286]=180,
		[724]=180,
		[109964]=60,
		[19236]=120,
		[47585]=120,
		[15487]=45,
	},
	["DRUID"]={
		[108294]=360,
		[124974]=90,
		[740]=180,
		[102342]=60,
		[22812]=60,
		[108238]=120,
		[61336]=180,
		[106898]=120,
		[106839]=15,
		[78675]=60,
		[16979]=15,
	},
	["SHAMAN"]={
		[108269]=45,
		[108281]=120,
		[98008]=180,
		[108280]=180,
		[2894]=300,
		[108271]=90,
		[108270]=60,
		[30823]=60,
		[57994]=12,
	},
	["MONK"]={
		[119381]=45,
		[115176]=180,
		[116849]=120,
		[115310]=180,
		[123986]=30,
		[115203]=180,
		[122278]=90,
		[122783]=90,
		[122470]=90,
		[116705]=15,
	},
	["WARLOCK"]={
		[111771]=10,
		[30283]=30,
		[104773]=180,
		[108359]=120,
		[110913]=180,
		[108416]=60,
		[19647]=24,
	},
	["DEATHKNIGHT"]={
		[51052]=120,
		[108200]=60,
		[108199]=60,
		[48792]=180,
		[42650]=600,
		[48707]=45,
		[48743]=120,
		[49222]=60,
		[49028]=90,
		[48982]=40,
		[55233]=60,
		[47528]=15,
		[47476]=60,
		[49576]=25,
	},
	["WARRIOR"]={
		[46968]=40,
		[97462]=180,
		[114030]=120,
		[114029]=30,
		[1160]=60,
		[871]=180,
		[118038]=120,
		[12975]=180,
		[55694]=60,
		[6552]=15,
	},
	["ROGUE"]={
		[76577]=180,
		[1966]=5,
		[36554]=20,
		[1766]=15,
	},
	["MAGE"]={
		[159916]=120,
		[45438]=300,
		[11426]=25,
		[110959]=90,
		[2139]=24,
		[1953]=15,
	},
	["HUNTER"]={
		[109248]=45,
		[172106]=180,
		[19263]=180,
		[109304]=120,
		[147362]=24,
	}
}
-------------
--check spell cooldown with locale
--for _,spelllist in pairs(RS_ClassSpellList)do
--	for spellid,_ in pairs(spelllist)do
--		local cd=RS.CoolDown.GetSpellCoolDown(spellid)
--		if(cd>0)then
--			--if(spelllist[spellid]~=cd)then
--			--	print("correction")
--			--	print(spellid)
--			--	print(cd)
--			--end
--			spelllist[spellid]=cd
--		end
--	end
--end
-------------
local CustomSpellDataList={
	--[PlayerName]={ spellid= cooldown}
}

RS.SpecAndSpells.SetCustomSpell=function(name,spellid,cooldown)
	if(not CustomSpellDataList[name])then
		CustomSpellDataList[name]={[spellid]=cooldown}
	else
		CustomSpellDataList[name][spellid]=cooldown
	end
end

local CheckSpellLib=function(name,spellid,cooldown)
	for _,spelllist in pairs(RS_ClassSpellList) do
		if(spelllist[spellid])then
			return
		end
	end
	RS.SpecAndSpells.SetCustomSpell(name,spellid,cooldown)
end

RS.EventHandler.RegisterEvent(1,"RS_SettingLoaded","SpecAndSpells",function()
	for _,sequence in pairs(RS_Profile) do
		for _,group in pairs(sequence) do
			for name,playerdata in pairs(group) do
				for spellid,cooldown in pairs(playerdata.SpellList) do
					CheckSpellLib(name,spellid,cooldown)
				end
				for spellid,cooldown in pairs(playerdata.SelectedSpell) do
					CheckSpellLib(name,spellid,cooldown)
				end
			end
		end
	end
end)
----------------------

RS.SpecAndSpells.GetSpellList=function(name)
	local specid=NameToSpec[name]
	local class=NameToClass[name]
	local spelllist=CopyTable(RS_ClassSpellList[class] or {})
	--don't check spec yet
	--if(specid)then
	--	local sortfunc=function(a,b)
	--		if(a~=b)then
	--			if(a.SpecList[specid])then
	--				return true
	--			elseif(b.SpecList[specid])then
	--				return false
	--			end
	--		end
	--	end
	--	table.sort(spelllist,sortfunc)
	--end
	if(CustomSpellDataList[name])then
		for spellid,cooldown in pairs(CustomSpellDataList[name]) do
			spelllist[spellid]=cooldown
		end
	end

	return spelllist
end


RS.SpecAndSpells.GetColorFromName=function(name)
	return RAID_CLASS_COLORS[NameToClass[name or "None"]] or {r=1,g=1,b=1,a=1}
end
RS.SpecAndSpells.GetColorFromClass=function(class)
	return RAID_CLASS_COLORS[class] or {r=1,g=1,b=1,a=1}
end

RS.SpecAndSpells.UnitIsInGroup=function(name)
	if(GroupNameToRole[name])then
		return true
	end
end

RS.SpecAndSpells.GeneratePlayerData=function(name,class)
	if(GroupNameToStr[name])then
		----local _, _, subgroup, _, _, _, _, online= GetRaidRosterInfo(str)
		return	{
			Name=name,
			Color=RS.SpecAndSpells.GetColorFromName(name),
			Role=GroupNameToRole[name],
			RoleIcon=RS.SpecAndSpells.GetRoleIcon(name),
			SpecIcon=RS.SpecAndSpells.GetSpecIcon(name),
			SpellList=RS.SpecAndSpells.GetSpellList(name),
			--SubGroup=subgroup,
			--IsOnline=online,
			SelectedSpell={},
		}
	else
		return {
			Name=name,
			Color=RS.SpecAndSpells.GetColorFromClass(class),
			Role=GroupNameToRole[name],
			RoleIcon=RS.SpecAndSpells.GetRoleIcon(name),
			SpecIcon=nil,
			SpellList=CopyTable(RS_ClassSpellList[class] or {}),
			--SubGroup=subgroup,
			--IsOnline=online,
			SelectedSpell={},
		}
	end
end
RS.SpecAndSpells.LookUpPlayerData=function(name)
	for i=1,40 do
		local str="raid"..i
		local unitname=GetFullName(str)
		if(unitname==name)then
			return RS.SpecAndSpells.GeneratePlayerData(name)
		end
	end
end