-- Author      : Nogarder
-- Create Date : 2015/3/9 20:18:12
RS.RegisterPageFunc("SpellAutoDetector",function()

	-----------------------------------------------------------------------------------------
	--blizzard use 2 different type of timestamp (i've no idea why)
	-----------------------------------------------------------------------------------------
	--when use UnitCastingInfo(), the time (either start or end) it gives is 
	--identical to gettime()*1000  (integer) ,which is 'the computer's OS's up time'
	------------------------------------------------------------------------------------------
	--and in combatlog event, the timestamp is comparable to time() with decimal places
	--which is a form of the current time (like 3:15 PM)
	-----------------------------------------------------------------------------------------
	--and time() only return interger without decimal,
	--thus there's no way to translate from one to another
	--those times just ain't comparable
	-----------------------------------------------------------------------------------------
	--but there's another thing,
	--for example ,when a event "SPELL_CAST_START" is fired,
	--use GetTime() in COMBAT_LOG_EVENT_UNFILTERED would get a cast start time,
	--at anytime later (long as the casting is not finished), use UnitCastingInfo on the unit, can get a casting start time,
	--these two times are same up to 2 decimal places,
	--which could mean there're no delay between system-built-in-events and addon-events,
	---------
	--i.e. if a spell is being casted
	--in combatlog event may have GetTime()=10.12
	--using UnitCastingInfo would have a StartTime=10121
	--it can be translated by floor(time/10)/100, into 10.12
	--then they match exactly, this is very usful to decide if the spell get from combatlog is the very same spell UnitCastingInfo returns
	-----------------------------------------------------------------------------------------
	--anyway, in combatlog, replace timestamp with GetTime(), it works surpresingly well XD
	-------------------------------------------------------------------------------------------
	--about healing changed in 6.0
	--healing arg[18]=critical arg[19]=multistrike
	--
	--SpellDamage(timestamp, eventtype, srcGUID, srcName, srcFlags,srcFlags2 dstGUID, dstName, dstFlags,dstFlags2	-- 1-11
	--	spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed 12-20
	--critical, glancing, crushing, isOffHand, multistrike)
	----combat event handler
	--register a combat event handler into main event handler
	local RS_EventHandler_FireEvent=RS.EventHandler.FireEvent
	--using one fixed table should speed it up
	local arg={
		[1]=1,
		[2]=1,
		[3]=1,
		[4]=1,
		[5]=1,
		[6]=1,
		[7]=1,
		[8]=1,
		[9]=1,
		[10]=1,
		[11]=1,
		[12]=1,
		[13]=1,
		[14]=1,
		[15]=1,
		[16]=1,
		[17]=1,
		[18]=1,
		[19]=1,
		[20]=1,
		[21]=1,
		[22]=1,
		[23]=1,
		[24]=1,
		[25]=1,
	}

	local pairs=pairs
	local table_insert=table.insert
	local bit_band=bit.band
	local next=next
	local floor=floor
	--
	local Localization=RS.Localization
	local Tooltips=Localization.Tooltips
	---
	local parent=RS.OptionsMain
	--
	local main=RS.Template.CreateFrameWithBar(parent,Localization["AutoDetector"],235,505,nil,nil)
	main:Hide()
	local page=main.Frame
	--
	page:SetWidth(235)
	page:SetHeight(525)
	--
	local width=90
	local step=-5
	--enablebox
	local enablebox=RS.Template.CreateCheckBox(page,225,20,Localization["Enable"])
	enablebox:SetPoint("TOPLEFT",page,"TOPLEFT",5,-5)
	RS.Template.SetTooltips(Tooltips["Enable"],enablebox)
	--from filter frame
	local fromframe=RS.Template.CreateFrame(page,110,230,nil,true,Localization["From"],1)
	fromframe:SetPoint("TOPLEFT",enablebox,"BOTTOMLEFT",0,-15)
	fromframe:EnableMouse(false)
	--from checker
	--object
	local fromobjectchecker=RS.Template.CreateCheckBox(fromframe,100,20,Localization["Object"])
	fromobjectchecker:SetPoint("TOPLEFT",fromframe,"TOPLEFT",5,-5)
	RS.Template.SetTooltips(Tooltips["Object"],fromobjectchecker)
	RS.Template.SetCheckBox(fromobjectchecker,true)
	--guardian
	local fromguardianchecker=RS.Template.CreateCheckBox(fromframe,100,20,Localization["Guardian"])
	fromguardianchecker:SetPoint("TOPLEFT",fromobjectchecker,"BOTTOMLEFT",0,-5)
	RS.Template.SetTooltips(Tooltips["Guardian"],fromguardianchecker)
	RS.Template.SetCheckBox(fromguardianchecker,true)
	--pet
	local frompetchecker=RS.Template.CreateCheckBox(fromframe,100,20,Localization["Pet"])
	frompetchecker:SetPoint("TOPLEFT",fromguardianchecker,"BOTTOMLEFT",0,-5)
	RS.Template.SetTooltips(Tooltips["Pet"],frompetchecker)
	RS.Template.SetCheckBox(frompetchecker,true)
	--NPC
	local fromnpcchecker=RS.Template.CreateCheckBox(fromframe,100,20,Localization["NPC"])
	fromnpcchecker:SetPoint("TOPLEFT",frompetchecker,"BOTTOMLEFT",0,-5)
	RS.Template.SetTooltips(Tooltips["NPC"],fromnpcchecker)
	RS.Template.SetCheckBox(fromnpcchecker,true)
	--player
	local fromplayerchecker=RS.Template.CreateCheckBox(fromframe,100,20,Localization["Player"])
	fromplayerchecker:SetPoint("TOPLEFT",fromnpcchecker,"BOTTOMLEFT",0,-5)
	RS.Template.SetTooltips(Tooltips["Player"],fromplayerchecker)
	RS.Template.SetCheckBox(fromplayerchecker,true)
	--target
	local fromtargetchecker=RS.Template.CreateCheckBox(fromframe,100,20,Localization["Target"])
	fromtargetchecker:SetPoint("TOPLEFT",fromplayerchecker,"BOTTOMLEFT",0,-5)
	RS.Template.SetTooltips(Tooltips["Target"],fromtargetchecker)
	RS.Template.SetCheckBox(fromtargetchecker,true)
	--focus
	local fromfocuschecker=RS.Template.CreateCheckBox(fromframe,100,20,Localization["Focus"])
	fromfocuschecker:SetPoint("TOPLEFT",fromtargetchecker,"BOTTOMLEFT",0,-5)
	RS.Template.SetTooltips(Tooltips["Focus"],fromfocuschecker)
	RS.Template.SetCheckBox(fromfocuschecker,true)
	--self
	local fromselfchecker=RS.Template.CreateCheckBox(fromframe,100,20,Localization["Self"])
	fromselfchecker:SetPoint("TOPLEFT",fromfocuschecker,"BOTTOMLEFT",0,-5)
	RS.Template.SetTooltips(Tooltips["Self"],fromselfchecker)
	RS.Template.SetCheckBox(fromselfchecker,true)
	--noone
	local fromnoonechecker=RS.Template.CreateCheckBox(fromframe,100,20,Localization["NoOne"])
	fromnoonechecker:SetPoint("TOPLEFT",fromselfchecker,"BOTTOMLEFT",0,-5)
	RS.Template.SetTooltips(Tooltips["NoOne"],fromnoonechecker)
	RS.Template.SetCheckBox(fromnoonechecker,true)
	--
	--to filter frame
	local toframe=RS.Template.CreateFrame(page,110,230,nil,true,Localization["CastOn"],1)
	toframe:SetPoint("TOPLEFT",fromframe,"TOPRIGHT",5,0)
	toframe:EnableMouse(false)
	--to checker
	--object
	local toobjectchecker=RS.Template.CreateCheckBox(toframe,100,20,Localization["Object"])
	toobjectchecker:SetPoint("TOPLEFT",toframe,"TOPLEFT",5,-5)
	RS.Template.SetTooltips(Tooltips["Object"],toobjectchecker)
	RS.Template.SetCheckBox(toobjectchecker,true)
	--guardian
	local toguardianchecker=RS.Template.CreateCheckBox(toframe,100,20,Localization["Guardian"])
	toguardianchecker:SetPoint("TOPLEFT",toobjectchecker,"BOTTOMLEFT",0,-5)
	RS.Template.SetTooltips(Tooltips["Guardian"],toguardianchecker)
	RS.Template.SetCheckBox(toguardianchecker,true)
	--pet
	local topetchecker=RS.Template.CreateCheckBox(toframe,100,20,Localization["Pet"])
	topetchecker:SetPoint("TOPLEFT",toguardianchecker,"BOTTOMLEFT",0,-5)
	RS.Template.SetTooltips(Tooltips["Pet"],topetchecker)
	RS.Template.SetCheckBox(topetchecker,true)
	--NPC
	local tonpcchecker=RS.Template.CreateCheckBox(toframe,100,20,Localization["NPC"])
	tonpcchecker:SetPoint("TOPLEFT",topetchecker,"BOTTOMLEFT",0,-5)
	RS.Template.SetTooltips(Tooltips["NPC"],tonpcchecker)
	RS.Template.SetCheckBox(tonpcchecker,true)
	--player
	local toplayerchecker=RS.Template.CreateCheckBox(toframe,100,20,Localization["Player"])
	toplayerchecker:SetPoint("TOPLEFT",tonpcchecker,"BOTTOMLEFT",0,-5)
	RS.Template.SetTooltips(Tooltips["Player"],toplayerchecker)
	RS.Template.SetCheckBox(toplayerchecker,true)
	--target
	local totargetchecker=RS.Template.CreateCheckBox(toframe,100,20,Localization["Target"])
	totargetchecker:SetPoint("TOPLEFT",toplayerchecker,"BOTTOMLEFT",0,-5)
	RS.Template.SetTooltips(Tooltips["Target"],totargetchecker)
	RS.Template.SetCheckBox(totargetchecker,true)
	--focus
	local tofocuschecker=RS.Template.CreateCheckBox(toframe,100,20,Localization["Focus"])
	tofocuschecker:SetPoint("TOPLEFT",totargetchecker,"BOTTOMLEFT",0,-5)
	RS.Template.SetTooltips(Tooltips["Focus"],tofocuschecker)
	RS.Template.SetCheckBox(tofocuschecker,true)
	--self
	local toselfchecker=RS.Template.CreateCheckBox(toframe,100,20,Localization["Self"])
	toselfchecker:SetPoint("TOPLEFT",tofocuschecker,"BOTTOMLEFT",0,-5)
	RS.Template.SetTooltips(Tooltips["Self"],toselfchecker)
	RS.Template.SetCheckBox(toselfchecker,true)
	--noone
	local tonoonechecker=RS.Template.CreateCheckBox(toframe,100,20,Localization["NoOne"])
	tonoonechecker:SetPoint("TOPLEFT",toselfchecker,"BOTTOMLEFT",0,-5)
	RS.Template.SetTooltips(Tooltips["NoOne"],tonoonechecker)
	RS.Template.SetCheckBox(tonoonechecker,true)
	--
	--spell list frame
	local spelllist=RS.Template.CreateCheckBoxList(page,205,180)
	spelllist.Scroll:SetPoint("TOPLEFT",fromframe,"BOTTOMLEFT",0,-5)
	--
	--reset button
	local resetbutton=RS.Template.CreateButton(page,225,15,Localization["Reset"])
	RS.Template.SetTooltips(Tooltips["Reset"],resetbutton,nil,2)
	resetbutton:SetPoint("TOPLEFT",spelllist.Scroll,"BOTTOMLEFT",0,-25)
	--detector
	local spelldata={}
	--
	local spellhandlertable={
		["SPELL_AURA_APPLIED"]=1, --1=apply aura
		["SPELL_AURA_APPLIED_DOSE"]=1,
		["SPELL_AURA_REMOVED"]=2,--2=remove aura
		["SPELL_AURA_REMOVED_DOSE"]=2,
		["SPELL_AURA_INTERRUPT"]=3,--3=interrupt spell
		["SPELL_CAST_START"]=4,--4=casting spell
		["SPELL_CAST_SUCCESS"]=4,
		["SPELL_SUMMON"]=5,--5=summon spell
		["SPELL_RESURRECT"]=6,--6=resurrect spell
		["SPELL_AURA_REFRESH"]=7,--7=refresh spell
		["SPELL_AURA_DISPEL"]=8,--stolen counts as dispel
		["SPELL_AURA_STOLEN"]=8,--8=dispel
		["SPELL_DAMAGE"]=9,--9=attack spell
		["SPELL_PERIODIC_DAMAGE"]=9,
		--["SPELL_MISSED"]=9,
		["SPELL_HEAL"]=10,--10=heal spell
		["SPELL_PERIODIC_HEAL"]=10,
		["SPELL_ENERGIZE"]=11,--11=enegrize spell
		["SPELL_PERIODIC_ENERGIZE"]=11,
		--["SPELL_DRAIN"]=12,--12=drain spell
		--["SPELL_PERIODIC_DRAIN"]=12,
	}
	local filterfrom=0
	local fiterto=0
	local areaname=GetInstanceInfo()
	--
	local selectedspell={}
	--
	RS.Template.SetCheckBoxList(spelllist,nil,
		function(name,value) --on value update, check selectlist
			selectedspell[name]=value
		end,
		function(name) --on enter ,show text list for info
			local textdata={}
			local data=spelldata[name]
			table_insert(textdata,{Text=Localization["Name"]..": "..(data.Name or ""),Offset=0})
			table_insert(textdata,{Text=Localization["Spellid"]..": "..name,Offset=0})
			table_insert(textdata,{Text=Localization["School"]..": "..(data.School or ""),Offset=0})
			table_insert(textdata,{Text=Localization["Icon"]..": "..(data.Icon or ""),Offset=0})
			table_insert(textdata,{Text=Localization["CastTime"]..": "..data.CastTime,Offset=0})
			table_insert(textdata,{Text=Localization["MinRange"]..": "..data.MinRange,Offset=0})
			table_insert(textdata,{Text=Localization["MaxRange"]..": "..data.MaxRange,Offset=0})
			if(data.CastElapse)then
				table_insert(textdata,{Text=Localization["CastElapse"]..": "..(floor(data.CastElapse*100)/100),Offset=0})
			end
			if(data.Length)then
				table_insert(textdata,{Text=Localization["Length"]..": "..(floor(data.Length*100)/100),Offset=0})
			end
			--
			if(data.IsInterruptSpell)then
				table_insert(textdata,{Text=Localization["InterruptSpell"],Offset=3})
			end
			if(data.IsSummonSpell)then
				table_insert(textdata,{Text=Localization["SummonSpell"],Offset=3})
			end
			if(data.IsDispelSpell)then
				table_insert(textdata,{Text=Localization["DispelSpell"],Offset=3})
			end
			if(data.IsHealSpell)then
				table_insert(textdata,{Text=Localization["HealSpell"],Offset=3})
			end
			if(data.IsResurrectSpell)then
				table_insert(textdata,{Text=Localization["ResurrectSpell"],Offset=3})
			end
			if(data.IsEnegrizeSpell)then
				table_insert(textdata,{Text=Localization["EnegrizeSpell"],Offset=3})
			end
			if(data.IsDispelAble)then
				table_insert(textdata,{Text=Localization["DispelAble"],Offset=3})
			end
			if(data.IsShiled)then
				table_insert(textdata,{Text=Localization["IsShield"],Offset=3})
			end
			--
			if(next(data.CastArea))then
				table_insert(textdata,{Text=Localization["CastArea"]..": ",Offset=0})
				for name,_ in pairs(data.CastArea)do
					table_insert(textdata,{Text=name,Offset=5})
				end
			end
			if(next(data.CasterName))then
				table_insert(textdata,{Text=Localization["Caster"]..": ",Offset=0})
				for name,flag in pairs(data.CasterName)do
					table_insert(textdata,{Text=name,Offset=5})
				end
			end
			if(next(data.CastOn))then
				table_insert(textdata,{Text=Localization["CastOn"]..": ",Offset=0})
				for name,flag in pairs(data.CastOn)do
					table_insert(textdata,{Text=name,Offset=5})
				end
			end
			--
			local textlist=RS.Template.SetTextList(page,1,textdata)
			textlist:SetPoint("TOPLEFT",spelllist.Scroll,"TOPRIGHT",30,0)
		end
		,function() --on leave, hide text list
			RS.Template.HideTextList()
		end)
	--
	local updatespelllist=function()
		local dataset={}
		for spellid,data in pairs(spelldata)do
			table_insert(dataset,{
				Name=spellid,
				Text=(data.Name or "").." ("..spellid..")",
				TextureFile=data.Icon
			})
		end
		RS.Template.UpdateCheckBoxListByData(spelllist,dataset)
	end
	--
	local CheckSpecial=function(guid,checker1,checker2,checker3)
		local passfrom
		if(guid)then
			if(
				(guid==UnitGUID("target") and checker1.Checked==true) or
				(guid==UnitGUID("focus") and checker2.Checked==true) or
				(guid==UnitGUID("player") and checker3.Checked==true)		
				)
				then
					return true
				end
		end
	end
	--
	local RS_SpellAutoDetector_OnEvent=function(arg)
		--special for shield spell
		if(arg[2]=="SPELL_ABSORBED")then
			if(arg[22])then
				if(not spelldata[arg[19]])then
					spelldata[arg[19]]={
						CasterName={},
						LastCast={},
						CastArea={},
						CastOn={},
						CastOnTimer={},
						IsShield=true}
					return
				end
				spelldata[arg[19]].IsShield=true
			elseif(arg[16])then
				if(not spelldata[arg[16]])then
					spelldata[arg[16]]={
						CasterName={},
						LastCast={},
						CastArea={},
						CastOn={},
						CastOnTimer={},
						IsShield=true}
					return
				end
				spelldata[arg[16]].IsShield=true
				return
			end
		end
		--
		if(arg[2] and arg[12])then
			local updated
			local index=spellhandlertable[arg[2]]
			--must have a caster name and fit in filters
			if(index and (
				((arg[5] and bit_band(arg[6],filterfrom)>0) or
				 (arg[5]==nil and fromnoonechecker.Checked==true) or
				 (arg[5] and CheckSpecial(arg[4],fromtargetchecker,fromfocuschecker,fromselfchecker))
				 ) and
				(
				 (arg[9] and bit_band(arg[10],filterto)>0) or 
				 (arg[9]==nil and tonoonechecker.Checked==true) or
				 (arg[9] and CheckSpecial(arg[8],totargetchecker,tofocuschecker,toselfchecker))
				)
				))then
					if(not spelldata[arg[12]])then
						spelldata[arg[12]]={
							CasterName={},
							LastCast={},
							CastArea={},
							CastOn={},
							CastOnTimer={}}
					end
					local data=spelldata[arg[12]]
					--basic info
					if(data.Name~=arg[13])then
						data.Name=arg[13]
						data.School=arg[14]
						--extra info
						local _, _,icon, casttime,minrange,maxrange=GetSpellInfo(arg[12])
						data.Icon=icon
						data.CastTime=floor((casttime or 0)/10)/100
						data.MinRange=minrange
						data.MaxRange=maxrange
						--update mark
						updated=true
					end
					--caster
					data.CasterName[arg[5] or "None"]=arg[6]
					--cast area
					data.CastArea[areaname]=true
					--cast upon
					data.CastOn[arg[9] or "None"]=arg[10]
					if(index~=2)then
						if(arg[9])then --check name rather than guid, as blizzard would give a 0x000 guid on unit not exists
							data.CastOnTimer[arg[8]]=arg[1]
						end
					elseif(data.CastOnTimer[arg[8]])then
						local length=arg[1]-data.CastOnTimer[arg[8]]
						if((not data.Length) or data.Length<length)then
							data.Length=length
						end
					end
					--special handler
					--stack
					if(index==1)then
						if((not data.MaxStack) or data.MaxStack<(arg[16] or 1))then
							data.MaxStack=arg[16] or 1
						end
					elseif(index==3)then
						--set interrupt spell
						data.IsInterruptSpell=true
					elseif(index==4)then
						--time between casts
						if(data.LastCast[arg[4]])then
							local elapse=arg[1]-data.LastCast[arg[4]]
							if((not data.CastElapse)or data.CastElapse>elapse)then
								data.CastElapse=elapse
							end
						end
						data.LastCast[arg[4]]=arg[1]
					elseif(index==5)then
						data.IsSummonSpell=true
					elseif(index==6)then
						data.IsResurrectSpell=true
					elseif(index==8)then
						data.IsDispelSpell=true
						if(spelldata[arg[15]])then
							spelldata[arg[15]].DispelAble=true
						end
					elseif(index==9)then
						data.IsDamageSpell=true
					elseif(index==10)then
						data.IsHealSpell=true
					elseif(index==11)then
						data.IsEnegrizeSpell=true
					end
					--update list display
					if(updated)then
						updatespelllist()
					end
				end
		end
	end

	enablebox.OnValueUpdateFunc=function()
		if(enablebox.Checked)then
			RS.EventHandler.RegisterEvent(0,"COMBAT_LOG_EVENT_UNFILTERED","RS_SpellAutoDetector",function(_,event,arg3,arg4,arg5,arg6,arg7,arg8,arg9,arg10,arg11,arg12,arg13,arg14,arg15,arg16,arg17,arg18,arg19,arg20,arg21,arg22,arg23,arg24,arg25)
				--wrapping data
				arg[1]=GetTime() --override timestamp with gettime
				arg[2]=event
				arg[3]=arg3
				arg[4]=arg4
				arg[5]=arg5
				arg[6]=arg6
				arg[7]=arg7
				arg[8]=arg8
				arg[9]=arg9
				arg[10]=arg10
				arg[11]=arg11
				arg[12]=arg12
				arg[13]=arg13
				arg[14]=arg14
				arg[15]=arg15
				arg[16]=arg16
				arg[17]=arg17
				arg[18]=arg18
				arg[19]=arg19
				arg[20]=arg20
				arg[21]=arg21
				arg[22]=arg22
				arg[23]=arg23
				arg[24]=arg24
				arg[25]=arg25
				--refire it with wrapped data
				RS_SpellAutoDetector_OnEvent(arg)
			end)
			RS.EventHandler.RegisterEvent(2,"DataCollector_PlayerEnteringWorld","RS_SpellAutoDetector",function(_,instancename)
				areaname=instancename
			end)
			--check collectable list for detailed info like spell type
			RS.EventHandler.RegisterEvent(2,"DataCollector_CollectUnit","RS_SpellAutoDetector",function(unit)			
				local i=1
				--seek every debuff on unit
				repeat
					--name,rank  icon , count , bufftype , duration , expirationtime , unitcaster , isstealable , shouldconsolidate , spellid = UnitBuff(unit,i)
					local name,_ ,_, _ , bufftype , duration , _ , _ , _ ,_ , spellid = UnitDebuff(unit,i)
					--
					if(spellid and spelldata[spellid])then
						spelldata[spellid].SpellType=bufftype or "None"
						spelldata[spellid].Length=spelldata[spellid].Length or duration
						
					end
					i=i+1
				until(not name)
				--and buff
				local i=1
				repeat
					--name,rank, icon , count , bufftype , duration , expirationtime , unitcaster , isstealable , shouldconsolidate , spellid = UnitBuff(unit,i)
					--15=absorbamount
					local name,_,_, _ , bufftype , duration , _ , _ , _ ,_ , spellid = UnitBuff(unit,i)
					--
					if(spellid and spelldata[spellid])then
						spelldata[spellid].SpellType=bufftype or "None"
						spelldata[spellid].Length=spelldata[spellid].Length or duration

					end
					i=i+1
				until(not name)
			end)
		else
			--unregister events
			RS.EventHandler.RegisterEvent(0,"COMBAT_LOG_EVENT_UNFILTERED","RS_SpellAutoDetector",nil)
			RS.EventHandler.RegisterEvent(2,"DataCollector_PlayerEnteringWorld","RS_SpellAutoDetector",nil)
			RS.EventHandler.RegisterEvent(2,"DataCollector_CollectUnit","RS_SpellAutoDetector",nil)
		end

	end
	local buildfilter=function()
		--generate filter flag
		filterfrom=0
		if(fromobjectchecker.Checked)then
			filterfrom=filterfrom+COMBATLOG_OBJECT_TYPE_OBJECT
		end
		if(fromguardianchecker.Checked)then
			filterfrom=filterfrom+COMBATLOG_OBJECT_TYPE_GUARDIAN
		end
		if(frompetchecker.Checked)then
			filterfrom=filterfrom+COMBATLOG_OBJECT_TYPE_PET
		end
		if(fromnpcchecker.Checked)then
			filterfrom=filterfrom+COMBATLOG_OBJECT_TYPE_NPC
		end
		if(fromplayerchecker.Checked)then
			filterfrom=filterfrom+COMBATLOG_OBJECT_TYPE_PLAYER
		end
		--
		filterto=0
		if(toobjectchecker.Checked)then
			filterto=filterto+COMBATLOG_OBJECT_TYPE_OBJECT
		end
		if(toguardianchecker.Checked)then
			filterto=filterto+COMBATLOG_OBJECT_TYPE_GUARDIAN
		end
		if(topetchecker.Checked)then
			filterto=filterto+COMBATLOG_OBJECT_TYPE_PET
		end
		if(tonpcchecker.Checked)then
			filterto=filterto+COMBATLOG_OBJECT_TYPE_NPC
		end
		if(toplayerchecker.Checked)then
			filterto=filterto+COMBATLOG_OBJECT_TYPE_PLAYER
		end
	end
	--
	fromobjectchecker.OnValueUpdateFunc=buildfilter
	fromguardianchecker.OnValueUpdateFunc=buildfilter
	frompetchecker.OnValueUpdateFunc=buildfilter
	fromnpcchecker.OnValueUpdateFunc=buildfilter
	fromplayerchecker.OnValueUpdateFunc=buildfilter
	fromtargetchecker.OnValueUpdateFunc=buildfilter
	fromfocuschecker.OnValueUpdateFunc=buildfilter
	fromselfchecker.OnValueUpdateFunc=buildfilter
	fromnoonechecker.OnValueUpdateFunc=buildfilter
	--
	toobjectchecker.OnValueUpdateFunc=buildfilter
	toguardianchecker.OnValueUpdateFunc=buildfilter
	topetchecker.OnValueUpdateFunc=buildfilter
	tonpcchecker.OnValueUpdateFunc=buildfilter
	toplayerchecker.OnValueUpdateFunc=buildfilter
	totargetchecker.OnValueUpdateFunc=buildfilter
	tofocuschecker.OnValueUpdateFunc=buildfilter
	toselfchecker.OnValueUpdateFunc=buildfilter
	tonoonechecker.OnValueUpdateFunc=buildfilter
	--
	main.OnSetFunc=buildfilter
	--
	RS.RegisterPage("SpellAutoDetector",main)

end)
