-- Author      : Nogarder
-- Create Date : 2015/3/2 1:47:53

RS.RegisterPageFunc("GroupEditor",function()
	local Localization=RS.Localization
	local Tooltips=Localization.Tooltips

	local parent=RS.OptionsMain
	local main=RS.Template.CreateFrameWithBar(parent,nil,620,620)
	local page=main.Frame
	--player selector
	local playerselector=RS.Template.CreatePlayerSelector(page,610,250,60,60)
	playerselector:SetPoint("TOPLEFT",page,"TOPLEFT",5,-5)
	--
	local playerspelllist=RS.Template.CreatePlayerSpellList(page,610,350,40)
	playerspelllist.Scroll:SetPoint("TOPLEFT",playerselector,"BOTTOMLEFT",0,-5)
	--
	local UpdateFunc
	--
	local CustomPlayerDataList={
	--	["TestName1"]={--debug
	--		Name="TestName1",
	--		Color={r=1,g=1,b=1,a=1},
	--		RaidID="player",
	--		Role="HEALER",
	--		RoleIcon={
	--			Left=0.75,
	--			Right=1,
	--			Top=0,
	--			Bottom=1,
	--		},
	--		SpecIcon="Interface\\LFGFrame\\LFGRole",
	--		SpellList={[1752]=100,[2098]=120,[69070]=200},
	--		SelectedSpell={[1752]=100},
	--	},
	--	["TestName2"]={--debug
	--		Name="TestName2",
	--		Color={r=1,g=0,b=1,a=1},
	--		RaidID="player",
	--		Role="Tank",
	--		RoleIcon={
	--			Left=0.5,
	--			Right=0.75,
	--			Top=0,
	--			Bottom=1,
	--		},
	--		SpecIcon="Interface\\LFGFrame\\LFGRole",
	--		SpellList={},
	--		SelectedSpell={},
	--	},
	--	["TestName3"]={--debug
	--		Name="TestName3",
	--		Color={r=1,g=1,b=1,a=1},
	--		RaidID="player",
	--		Role="HEALER",
	--		RoleIcon={
	--			Left=0.75,
	--			Right=1,
	--			Top=0,
	--			Bottom=1,
	--		},
	--		SpecIcon="Interface\\LFGFrame\\LFGRole",
	--		SpellList={[1752]=100,[2098]=120,[69070]=200},
	--		SelectedSpell={[1752]=100},
	--	},
	--	["TestName4"]={--debug
	--		Name="TestName4",
	--		Color={r=1,g=1,b=1,a=1},
	--		RaidID="player",
	--		Role="HEALER",
	--		RoleIcon={
	--			Left=0.75,
	--			Right=1,
	--			Top=0,
	--			Bottom=1,
	--		},
	--		SpecIcon="Interface\\LFGFrame\\LFGRole",
	--		SpellList={[1752]=100,[2098]=120,[69070]=200},
	--		SelectedSpell={[1752]=100},
	--	},
	}
	--
	local SortByRoleFunc=function(a,b)
		if(a.Role~=b.Role)then
			if(a.Role=="HEALER")then
				return true
			elseif(b.Role=="HEALER")then
				return false
			elseif(a.Role=="TANK")then
				return true
			elseif(b.Role=="TANK")then
				return false
			end
		end
		--if(a.SubGroup<b.SubGroup)then
		--	return true
		--elseif(a.Index<b.Index)then
		--	return true
		--end
	end
	---
	local UpdatePlayerList=function()
		local playerdatalist={}
		local inraidlist={}

		local name=RS.SpecAndSpells.GetFullName("player")
		if(name)then
			inraidlist[name]=true
			table.insert(playerdatalist,RS.SpecAndSpells.GeneratePlayerData(name))
		end

		--players in current list, whether they're in raid or not 
		for name,playerdata in pairs(playerselector.SelectedPlayer) do
			if(not inraidlist[name])then
				inraidlist[name]=true
				CustomPlayerDataList[name]=playerdata
				table.insert(playerdatalist,playerdata)
			end
		end
		--debug list
		--for name,playerdata in pairs(CustomPlayerDataList) do
		--	if(not inraidlist[name])then
		--		inraidlist[name]=true
		--		table.insert(playerdatalist,playerdata)
		--	end
		--end
		--add current raid members
		for i=1,40 do
			local str="raid"..i
			local name=RS.SpecAndSpells.GetFullName(str)
			if(name and not inraidlist[name])then
				inraidlist[name]=true
				table.insert(playerdatalist,RS.SpecAndSpells.GeneratePlayerData(name))
			end
		end

		table.sort(playerdatalist,SortByRoleFunc)
		--
		RS.Template.SetPlayerSelector(playerselector,playerdatalist)
	end
	---------

	local UpdatePlayerSpellList=function()
		RS.Template.UpdatePlayerSpellList(playerspelllist,playerselector.SelectedPlayer)
	end

	local OnPlayerUpdateFunc=function()
		UpdatePlayerSpellList()
		UpdateFunc()
	end

	local OnSpellUpdateFunc=function()
		UpdateFunc()
	end

	playerselector.OnPlayerAddedFunc=OnPlayerUpdateFunc
	playerselector.OnPlayerRemovedFunc=OnPlayerUpdateFunc
	playerselector.OnPlayerCheckFunc=OnPlayerUpdateFunc
	playerselector.OnPlayerUncheckFunc=OnPlayerUpdateFunc

	playerspelllist.OnSpellAddFunc=OnSpellUpdateFunc
	playerspelllist.OnSpellRemovedFunc=OnSpellUpdateFunc
	playerspelllist.OnSpellUncheckFunc=OnSpellUpdateFunc
	playerspelllist.OnSpellCheckFunc=OnSpellUpdateFunc
	playerspelllist.OnPlayerClickFunc=function(playerdata)
		playerselector.SelectedPlayer[playerdata.Name]=nil
		OnPlayerUpdateFunc()
	end

	-----------
	main.OnSetFunc=function(Entry,button,updatefunc)
		playerselector.SelectedPlayer=Entry[button.EntryIndex]
		UpdateFunc=updatefunc

		UpdatePlayerList()
		UpdatePlayerSpellList()
		--
		RS.EventHandler:RegisterEvent(1,"SpecUpdated","GroupPlayerSelector",function(name)
			local playerdata=RS.SpecAndSpells.GeneratePlayerData(name)
			RS.Template.UpdatePlayerSelectorByPlayerData(playerselector,playerdata)
		end)
	end

	main:HookScript("OnHide",function()
		RS.EventHandler.RegisterEvent(0,"GROUP_ROSTER_UPDATE","GroupPlayerSelector",nil)
		RS.EventHandler:RegisterEvent(1,"SpecUpdated","GroupPlayerSelector",nil)
	end)
		--
	RS.RegisterPage("GroupEditor",main)

end)
