﻿-- Author      : Nogarder
-- Create Date : 2012/4/11 14:54:21
-- Author      : Nogarder
-- Create Date : 2012/4/11 14:54:21
local Localization=RS.Localization
local Tooltips=Localization.Tooltips
--
RS.Template.CreateSystemButton=function(parent,width,height,text)
	local button=CreateFrame("Button",nil,parent)
	button:SetHeight(15)
	button:SetWidth(width)
	--label
	button.Label=button:CreateFontString(nil,"OVERLAY")
	button.Label:SetFont(RS.TextFont,10,RS.TextMode)
	button.Label:SetPoint("TOPLEFT",button,"TOPLEFT",0,0)
	button.Label:SetPoint("BOTTOMRIGHT",button,"BOTTOMRIGHT",0,0)
	button.Label:SetText(text)
	button:EnableMouse(true)
	--background
	button.Background=RS.Template.CreateBackground(button)
	--script
	RS.Template.SetAutoFocus(button)
	--
	return button
end
--create
RS.Template.CreateButton=function(parent,width,height,text)
	local button=CreateFrame("Frame",nil,parent)
	--background
	button.Background=RS.Template.CreateBackground(button)
	--script
	RS.Template.SetAutoFocus(button)
	--
	height=height or 10
	--label
	button.Label=button:CreateFontString(nil,"OVERLAY")
	button.Label:SetFont(RS.TextFont,height-2,RS.TextMode)
	button.Label:SetPoint("CENTER",button,"CENTER",0,0)
	button.Label:SetText(text)
	button:EnableMouse(true)
	button.Texture=button:CreateTexture(nil,"ARTWORK")
	button.Texture:SetPoint("TOPLEFT",button,"TOPLEFT")
	button.Texture:SetPoint("BOTTOMRIGHT",button,"BOTTOMRIGHT")
	--
	button:SetHeight(height)

	if(not text)then
		text=" "
	end
	if(not width)then
		if(text)then
			width=button.Label:GetWidth()+4
		else
			width=10
		end
	end
	button:SetWidth(width)
	--show
	button:Show()
	--return pointer
	return button
end
--macro for disable button
RS.Template.DisableButton=function(button)
	if(not button.DisableLiner)then
		local texture=button:CreateTexture(nil,"OVERLAY")
		texture:SetPoint("LEFT",button,"LEFT",0,0)
		texture:SetPoint("RIGHT",button,"RIGHT",0,0)
		texture:SetHeight(button:GetHeight()/5)
		texture:SetTexture("Interface\\Addons\\RaidSequence\\texture\\Liner")
		texture:Show()
		button.DisableLiner=texture
	else
		button.DisableLiner:Show()
	end
	button.Disabled=true
	button:EnableMouse(false)
end
--macro for enable button
RS.Template.EnableButton=function(button)
	if(button.DisableLiner)then
		button.DisableLiner:Hide()
	end
	button.Disabled=nil
	button:EnableMouse(true)
end
--macro for set preview
RS.Template.SetButtonPreview=function(button,unit)
	if(not unit)then
		RS.SetTextFont(button.Label)
		RS.SetTexture(button.Texture)
		button:SetWidth(button.Label:GetWidth()+10)
	else
		if(unit.Disabled)then
			RS.Template.DisableButton(button)
		else
			RS.Template.EnableButton(button)
		end
		--preview
		RS.SetTextFont(button.Label,unit.Font,unit.FontProfileName)
		RS.SetTexture(button.Texture,unit.TextureProfileName,unit.TextureFile,"BLEND",{R=1,G=1,B=1,A=1},0,0,1,0,1)
		if(unit.SquareTexture)then
			button.Texture:ClearAllPoints()
			button.Texture:SetPoint("TOPLEFT",button,"TOPLEFT")
			button.Texture:SetPoint("BOTTOMLEFT",button,"BOTTOMLEFT")
			button.Texture:SetWidth(button:GetHeight())
			button.Label:ClearAllPoints()
			button.Label:SetPoint("LEFT",button.Texture,"RIGHT",0,0)
			button:SetWidth(button:GetHeight()+button.Label:GetWidth()+10)
		else
			button.Texture:ClearAllPoints()
			button.Texture:SetPoint("TOPLEFT",button,"TOPLEFT")
			button.Texture:SetPoint("BOTTOMRIGHT",button,"BOTTOMRIGHT")
			button.Label:ClearAllPoints()
			button.Label:SetPoint("CENTER",button,"CENTER",0,0)
			button:SetWidth(button.Label:GetWidth()+10)
		end
		if(unit.Color)then
			local color=unit.Color
			button.Label:SetTextColor(color.R,color.G,color.B,color.A)
			button.Texture:SetVertexColor(color.R,color.G,color.B,color.A)
		end
	end
end
--macro for special button
RS.Template.CreateSpecialButton=function(parent,width,height,btype)
	local button=RS.Template.CreateButton(parent,width,height,Localization[btype])
	RS.Template.SetTooltips(Tooltips[btype],button)
	return button
end
