-- Author      : Nogarder
-- Create Date : 2015/3/2 3:40:48
local RS_Template_FrameList_SetFocusBox=function(focusbox,button)
	focusbox.Name=button.Text
	focusbox:ClearAllPoints()
	focusbox:SetPoint("TOPLEFT",button,"TOPLEFT",-2,2)
	focusbox:SetPoint("BOTTOMRIGHT",button,"BOTTOMRIGHT",2,-2)
	focusbox:Show()
end

local RS_Template_FrameList_CreateButton=function(selectlist)
	local button=RS.Template.CreateButton(selectlist,selectlist:GetWidth()-8,15,nil)
	button.Index=0
	--
	RS.RunFunc(selectlist.ButtonCreateFunc,button)
	return button
end
RS.Template.UpdateFrameList=function(scroll,data)
	local selectlist=scroll.Frame

	local buttons=selectlist.Buttons
	local count=table.getn(data)
	--
	local maxwidth=RS.Animation.GetScrollWidth(scroll)-10
	--set frame height
	local height=selectlist.ButtonHeight*(count+1)+5
	if(height<scroll:GetHeight())then
		height=scroll:GetHeight()
	end
	selectlist:SetHeight(height)
	--
	for i=1,count do
		local unit=data[i]
		if(not buttons[i])then
			buttons[i]=RS_Template_FrameList_CreateButton(selectlist)
		end
		local button=buttons[i]
		button.Index=i
		button:ClearAllPoints()

		button:SetPoint("BOTTOMLEFT",selectlist,"TOPLEFT",5,-(selectlist.ButtonHeight*i))
		--button:SetPoint("BOTTOMRIGHT",selectlist,"TOPRIGHT",-5,-(selectlist.ButtonHeight*i))
		button:SetHeight(selectlist.ButtonHeight-5)
		--
		if(unit and unit.Disabled)then
			RS.Template.DisableButton(button)
		else
			RS.Template.EnableButton(button)
		end
		--
		RS.RunFunc(selectlist.ButtonUpdateFunc,button,unit)
		--
		button:Show()

		local width=button:GetWidth()
		if(maxwidth<width)then
			maxwidth=width
		end
		i=i+1
	end
	--
	selectlist.AddButton:SetPoint("BOTTOMLEFT",selectlist,"TOPLEFT",10,-(selectlist.ButtonHeight*(count+1)))
	--
	for i=count+1,table.getn(buttons)do
		buttons[i]:Hide()
	end

	--set all button to max width
	for j=1,count do
		buttons[j]:SetWidth(maxwidth)
	end
	--
	maxwidth=maxwidth+8
	--
	selectlist:SetWidth(maxwidth)
	--update scrollframe
	RS.Template.UpdateScrollFrame(selectlist)
	--
	scroll:Show()
end

RS.Template.CreateFrameList=function(parent,width,height,buttonheight,text,tooltips)
	local frame=RS.Template.CreateScrollFrame(parent,width,height)
	frame:HookScript("OnMouseDown",function()
		parent:GetScript("OnMouseDown")()
	end)
	frame:HookScript("OnMouseUp",function()
		parent:GetScript("OnMouseUp")()
	end)

	frame.Scroll:Hide()
	frame.ButtonHeight=buttonheight or 20
	--button list
	frame.Buttons={}

	--tooltips
	RS.Template.SetTooltips(tooltips,frame.Scroll)
	RS.Template.SetTooltips(tooltips,frame,nil,nil,frame.Scroll)
	--
	frame.AddButton=RS.Template.CreateButton(frame,width-18,frame.ButtonHeight-5,"+")
	frame.AddButton:HookScript("OnMouseUp",function()
		RS.RunFunc(frame.OnAddFunc)
	end)
	--
	frame.Tooltips=tooltips
	return frame.Scroll
end