-- Author      : Nogarder
-- Create Date : 2015/3/3 20:00:17

RS.Template.CreateSequenceFrame=function(frame)
	frame.GroupList={}
	frame.DirectionButton=RS.Template.CreateButton(frame.TitleButton,15,15,"\\")
	frame.DirectionButton:SetPoint("LEFT",frame.TitleButton,"LEFT")
	frame.DirectionButton:HookScript("OnMouseUp",function()
		frame.Vertical=not frame.Vertical
		RS.Template.UpdateSequenceFrame(frame)
	end)

	frame.CloseButton=RS.Template.CreateButton(frame.TitleButton,15,15,"X")
	frame.CloseButton:SetPoint("RIGHT",frame.TitleButton,"RIGHT")
	frame.CloseButton:HookScript("OnMouseUp",function()
		frame:Hide()
	end)

	frame.FocusBox=CreateFrame("Frame",nil,frame)
	frame.FocusBox:SetWidth(10)
	frame.FocusBox:SetHeight(10)
	frame.FocusBox:Hide()

	RS.Template.CreateLinerBorder(frame.FocusBox,1)
	RS.Template.SetLinerBorderFocus(frame.FocusBox,1)

	frame.LastUpdate=0
	frame.GroupCount=0

	frame:HookScript("OnUpdate",function(self)
		local nTime=GetTime()
		if(self.LastUpdate>nTime)then
			return
		end
		self.LastUpdate=nTime+RS.UpdateInterval

		local grouplist=frame.GroupList

		local bestpercent=0
		local bestindex
		for i=1,frame.GroupCount do
			local group=grouplist[i]
			if(group:IsShown() and group.GroupCount~=0)then
				local playerframes=group.PlayerFrames
				local dpercent=0
				for j=1,group.GroupCount do
					dpercent=dpercent+playerframes[j].Percent or 1
				end
				dpercent=dpercent/group.GroupCount
				if(dpercent>bestpercent)then
					bestpercent=dpercent
					bestindex=i
				end
			end
		end
		if(bestindex)then
			frame.FocusBox:ClearAllPoints()
			frame.FocusBox:SetPoint("CENTER",grouplist[bestindex],"CENTER")
			frame.FocusBox:Show()
		else
			frame.FocusBox:Hide()
		end
	end)
end

RS.Template.SetSequenceFrame=function(frame,entry,name)
	frame.Name=name or ""
	frame.Entry=entry
	frame.FocusBox:Hide()
end


RS.Template.UpdateSequenceFrame=function(frame)
	local grouplist=frame.GroupList
	local entry=frame.Entry

	local max=table.getn(entry)
	local width=frame:GetWidth()
	local height=frame:GetHeight()

	if(frame.Vertical)then
		width=width/max
		for index=1,max do
			if(not grouplist[index])then
				grouplist[index]=RS.Template.CreatePlayerGroup(frame)
			end
			local group=grouplist[index]
			local groupdata=entry[index]
			group:ClearAllPoints()
			group:SetWidth(width-5)
			group:SetHeight(height-5)
			group:SetPoint("LEFT",frame,"LEFT",5+(index-1)*width,-2)
			group.Vertical=frame.Vertical
			RS.Template.SetPlayerGroup(group,groupdata,false,index)
			RS.Template.EnablePlayerGroupCoolDown(group)
			group:Show()
		end
		for i=max+1,table.getn(grouplist) do
			grouplist[i]:Hide()
		end
		frame.FocusBox:SetWidth(width)
		frame.FocusBox:SetHeight(height)
	else
		height=height/max
		for index=1,max do
			if(not grouplist[index])then
				grouplist[index]=RS.Template.CreatePlayerGroup(frame)
			end
			local group=grouplist[index]
			local groupdata=entry[index]
			group:ClearAllPoints()
			group:SetWidth(width-5)
			group:SetHeight(height-5)
			group:SetPoint("TOP",frame,"TOP",2,-5-(index-1)*height)
			group.Vertical=frame.Vertical
			RS.Template.SetPlayerGroup(group,groupdata,false,index)
			RS.Template.EnablePlayerGroupCoolDown(group)
			group:Show()
		end
		for i=max+1,table.getn(grouplist) do
			grouplist[i]:Hide()
		end
		
		frame.FocusBox:SetWidth(width)
		frame.FocusBox:SetHeight(height)
	end
	frame.GroupCount=max
	frame.FocusBox:Hide()
end